Package net.sf.saxon.functions.registry

## Class BuiltInFunctionSet

- java.lang.Object
- - net.sf.saxon.functions.registry.BuiltInFunctionSet

- All Implemented Interfaces:
    `FunctionLibrary`
  Direct Known Subclasses:
    `ArrayFunctionSet`, `EXPathFileFunctionSet`, `ExsltCommonFunctionSet`, `IXSLFunctionSet`, `MapFunctionSet`, `MathFunctionSet`, `SQLFunctionSet`, `UseWhen30FunctionSet`, `VendorFunctionSetEE`, `VendorFunctionSetHE`, `VendorFunctionSetPE`, `XPath20FunctionSet`, `XPath30FunctionSet`, `XPath31FunctionSet`, `XQUpdate10FunctionSet`, `XSLT30FunctionSet`

      public abstract class BuiltInFunctionSet
      extends java.lang.Object
      implements FunctionLibrary

  This class is used to contain information about a set of built-in functions.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `BuiltInFunctionSet.Entry` | An entry in the table describing the properties of a function

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected static int` | `ABS` |
    `static int` | `AS_ARG0` | Function properties
    `static int` | `AS_PRIM_ARG0` |
    `static int` | `BASE` |
    `static int` | `CARD0` |
    `static int` | `CDOC` |
    `static int` | `CITEM` |
    `static int` | `DCOLL` |
    `static int` | `DEPENDS_ON_STATIC_CONTEXT` |
    `static int` | `DLANG` |
    `static Sequence` | `EMPTY` |
    `static int` | `FILTER` |
    `static int` | `FOCUS` |
    `protected static int` | `INS` | Classification of function arguments for serialization purposes; note that values must not conflict with bit settings used for cardinalities
    `static int` | `LAST` |
    `static int` | `LATE` |
    `protected static int` | `NAV` |
    `static int` | `NEW` |
    `static int` | `NS` |
    `static int` | `ONE` | Local names used for cardinality values
    `static int` | `OPT` |
    `static int` | `PLUS` |
    `static int` | `POSN` |
    `static int` | `SIDE` |
    `static int` | `STAR` |
    `protected static int` | `TRA` |
    `static int` | `UO` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BuiltInFunctionSet()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `bind​(SymbolicName.F symbolicName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `java.lang.String` | `getConventionalPrefix()` | Return a conventional prefix for use with this namespace, typically the prefix used in the documentation of these functions.
    `BuiltInFunctionSet.Entry` | `getFunctionDetails​(java.lang.String name, int arity)` | Locate the entry for a function with a given name and arity, if it exists
    `Function` | `getFunctionItem​(SymbolicName.F symbolicName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `java.lang.String` | `getNamespace()` | Return the namespace URI for the functions local to this function set.
    `void` | `importFunctionSet​(BuiltInFunctionSet importee)` | Import another function set (which must be in the same namespace)
    `boolean` | `isAvailable​(SymbolicName.F symbolicName)` | Test whether a function with a given name and arity is available
    `SystemFunction` | `makeFunction​(java.lang.String name, int arity)` |
    `protected BuiltInFunctionSet.Entry` | `register​(java.lang.String name, int arity, java.lang.Class<? extends SystemFunction> implementationClass, ItemType itemType, int cardinality, int properties)` | Register a system function in the table of function details.
    `protected void` | `registerReducedArityVariants​(java.lang.String key, int min, int max)` | Register reduced-arity versions of a function, with arities in a specified range, using common argument and return types

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Field Detail

    - #### EMPTY

          public static Sequence EMPTY

    - #### ONE

          public static final int ONE

      Local names used for cardinality values
      See Also:
        Constant Field Values

    - #### OPT

          public static final int OPT

      See Also:
        Constant Field Values

    - #### STAR

          public static final int STAR

      See Also:
        Constant Field Values

    - #### PLUS

          public static final int PLUS

      See Also:
        Constant Field Values

    - #### AS_ARG0

          public static final int AS_ARG0

      Function properties
      See Also:
        Constant Field Values

    - #### AS_PRIM_ARG0

          public static final int AS_PRIM_ARG0

      See Also:
        Constant Field Values

    - #### CITEM

          public static final int CITEM

      See Also:
        Constant Field Values

    - #### BASE

          public static final int BASE

      See Also:
        Constant Field Values

    - #### NS

          public static final int NS

      See Also:
        Constant Field Values

    - #### DCOLL

          public static final int DCOLL

      See Also:
        Constant Field Values

    - #### DLANG

          public static final int DLANG

      See Also:
        Constant Field Values

    - #### FILTER

          public static final int FILTER

      See Also:
        Constant Field Values

    - #### LATE

          public static final int LATE

      See Also:
        Constant Field Values

    - #### UO

          public static final int UO

      See Also:
        Constant Field Values

    - #### POSN

          public static final int POSN

      See Also:
        Constant Field Values

    - #### LAST

          public static final int LAST

      See Also:
        Constant Field Values

    - #### SIDE

          public static final int SIDE

      See Also:
        Constant Field Values

    - #### CDOC

          public static final int CDOC

      See Also:
        Constant Field Values

    - #### CARD0

          public static final int CARD0

      See Also:
        Constant Field Values

    - #### NEW

          public static final int NEW

      See Also:
        Constant Field Values

    - #### DEPENDS_ON_STATIC_CONTEXT

          public static final int DEPENDS_ON_STATIC_CONTEXT

      See Also:
        Constant Field Values

    - #### FOCUS

          public static final int FOCUS

      See Also:
        Constant Field Values

    - #### INS

          protected static final int INS

      Classification of function arguments for serialization purposes; note that values must not conflict with bit settings used for cardinalities
      See Also:
        Constant Field Values

    - #### ABS

          protected static final int ABS

      See Also:
        Constant Field Values

    - #### TRA

          protected static final int TRA

      See Also:
        Constant Field Values

    - #### NAV

          protected static final int NAV

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### BuiltInFunctionSet

          public BuiltInFunctionSet()

  - ### Method Detail

    - #### importFunctionSet

          public final void importFunctionSet​(BuiltInFunctionSet importee)

      Import another function set (which must be in the same namespace)
      Parameters:
        `importee` - the function set to be imported. (No cycles allowed!)

    - #### getFunctionDetails

          public BuiltInFunctionSet.Entry getFunctionDetails​(java.lang.String name,
                                                             int arity)

      Locate the entry for a function with a given name and arity, if it exists
      Parameters:
        `name` - the local part of the function name
        `arity` - the arity of the function. -1 considers all possibly arities and returns an arbitrary function if one exists with the right name.
      Returns:
        the entry for the required function, or null if not found

    - #### bind

          public Expression bind​(SymbolicName.F symbolicName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `symbolicName` - the symbolic name of the function being called
        `staticArgs` - May be null; if present, the length of the array must match the value of arity. Contains the expressions supplied statically in arguments to the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

        The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

        `env` - The static context of the function call
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An expression equivalent to a call on the specified function, if one is found; null if no function was found matching the required name and arity.

    - #### makeFunction

          public SystemFunction makeFunction​(java.lang.String name,
                                             int arity)
                                      throws XPathException

      Throws:
        `XPathException`

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F symbolicName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `symbolicName` - the qualified name of the function being called, together with its arity. For legacy reasons, the arity may be set to -1 to mean any arity will do
      Returns:
        true if a function of this name and arity is available for calling

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F symbolicName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `symbolicName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### register

          protected BuiltInFunctionSet.Entry register​(java.lang.String name,
                                                      int arity,
                                                      java.lang.Class<? extends SystemFunction> implementationClass,
                                                      ItemType itemType,
                                                      int cardinality,
                                                      int properties)

      Register a system function in the table of function details.
      Parameters:
        `name` - the function name
        `implementationClass` - the class used to implement the function
        `itemType` - the item type of the result of the function
        `cardinality` - the cardinality of the result of the function
        `properties` - bitwise properties of the function
      Returns:
        the entry describing the function. The entry is incomplete, it does not yet contain information about the function arguments.

    - #### registerReducedArityVariants

          protected void registerReducedArityVariants​(java.lang.String key,
                                                      int min,
                                                      int max)

      Register reduced-arity versions of a function, with arities in a specified range, using common argument and return types

    - #### getNamespace

          public java.lang.String getNamespace()

      Return the namespace URI for the functions local to this function set.
      Returns:
        the namespace URI of the functions local to this function set. Note that functions imported from another function set may have a different namespace URI.

    - #### getConventionalPrefix

          public java.lang.String getConventionalPrefix()

      Return a conventional prefix for use with this namespace, typically the prefix used in the documentation of these functions.